import java.util.ArrayList;

/**
 *  Sorting Algorithms Lecture:<br>
 *  An object of this class sorts data using an Insertion Sort.
 *
 *  @author Alyce Brady
 *  @version 16 February 2016
 */
public class InsertionSorter implements Sorter
{
  // State: instance variables go here.
    private String description;

  // Constructor

    /**
     * Constructs a new object of this class.
     */
    public InsertionSorter()
    {
        // initialise instance variables
        this.description = "Insertion Sort";
    }

  // Methods
  
    /**
     * Describes which sorting algorithm this is.
     */
    public String getDescription()
    {
        return this.description;
    }

    /**
     * Sorts the data in the ArrayList of data.
     */
    public void sort(ArrayList<String> data)
    {
        // Insert the second one in the correct spot to its left; then
        // insert the third one in the correct spot to its left, etc.
        for ( int focus = 1; focus < data.size(); focus++ )
        {
            // Insert in correct spot, moving all larger ones up.
            String temp = data.get(focus);
            int insertionIndex = findInsertionPoint(data, temp, focus);
            data.set(insertionIndex, temp);

        }
    }

    /**
     * Finds insertion point to the comparison string to its left, and shifts
     * everything larger to the comparison string up one.
     */
    private int findInsertionPoint(ArrayList<String> data, String comparison,
                                 int startIndex)
    {
        for ( int k = startIndex - 1; k >= 0; k-- )
        {
            // If next one we look at is larger, move it up one.
            if ( data.get(k).compareTo(comparison) > 0 )
            {
                data.set(k+1, data.get(k));
            }
            else
            {
                return k + 1;
            }
        }
        return 0;
    }

}
